//  IDVI 1.1 source copyright 1996-97 Garth A. Dickie
//
//  This source is free for non-commercial use.  No warranty, etc.
//  Please acknowledge reuse by including the line:
//
//  "Based in part on IDVI 1.1 source copyright 1996-97 Garth A. Dickie"
//
//  in your documentation and source code.  For commercial use or
//  distribution, please contact the author.  Please also send
//  questions, comments, bug reports, or fixes.
//
//  A description of the class hierarchy and some design notes are
//  available at <http://www.geom.umn.edu/java/idvi/designnotes/>.
//
//  Best Regards,
//  Garth A. Dickie
//  dickie@elastic.avid.com

package ibook.v11.applet;

import java.applet.Applet;
import java.applet.AppletContext;
import java.applet.AudioClip;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.image.ColorModel;
import java.net.URL;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.io.InputStream;

//  The FilterAppletContext class should be extended, with
//  appropriate AppletContext methods overridden in the
//  derived class.

public class FilterAppletContext implements AppletContext {
    private AppletContext context;
    private HashMap streams;

    public FilterAppletContext( AppletContext context ) {
        this.context = context;
	this.streams = new HashMap();
    }

    //  Here are all of the methods of the AppletContext interface,
    //  with trivial implementations:

    public AudioClip getAudioClip( URL url) {
        return context.getAudioClip( url );
    }

    public Image getImage( URL url ) {
        return context.getImage( url );
    }

    public Applet getApplet( String name) {
        return context.getApplet( name );
    }

    public Enumeration getApplets( ) {
        return context.getApplets( );
    }

    public void showDocument( URL url ) {
        context.showDocument( url );
    }

    public void showDocument( URL url, String target ) {
        context.showDocument( url, target );
    }

    public void showStatus( String status ) {
        context.showStatus( status );
    }

    public void setStream( String key, java.io.InputStream stream ) throws java.io.IOException {
	this.streams.put( key, stream );
    }

    public java.io.InputStream getStream( String key ) {
	return (java.io.InputStream) this.streams.get( key );
    }

    public java.util.Iterator getStreamKeys() {
	return this.streams.keySet().iterator();
    }
}
